from optimizer import solve_optimization
from structs.landmarks import LandmarkTest
from structs.landmarks import Landmark
from structs.preferences import Preferences
from fastapi import FastAPI, Query, Body
from typing import List

app = FastAPI()


# Assuming frontend is calling like this : 
#"http://127.0.0.1:8000/process?param1={param1}&param2={param2}"
# This should become main at some point
@app.post("/optimizer/{longitude}/{latitude}")
def main(longitude: float, latitude: float, prefrences: Preferences = Body(...)) -> List[Landmark]:
    # From frontend get longitude, latitude and prefence list

    landmarks = []


    return landmarks

@app.get("test")
def test():
    
    # CONSTRAINT TO RESPECT MAX NUMBER OF STEPS
    max_steps = 16


    # Initialize all landmarks (+ start and goal). Order matters here
    landmarks = []
    landmarks.append(LandmarkTest("départ", -1, (0, 0)))
    landmarks.append(LandmarkTest("tour eiffel", 99, (0,2)))                           # PUT IN JSON
    landmarks.append(LandmarkTest("arc de triomphe", 99, (0,4)))
    landmarks.append(LandmarkTest("louvre", 99, (0,6)))
    landmarks.append(LandmarkTest("montmartre", 99, (0,10)))
    landmarks.append(LandmarkTest("concorde", 99, (0,8)))
    landmarks.append(LandmarkTest("arrivée", -1, (0, 0)))


    visiting_order = solve_optimization(landmarks, max_steps, True)

    return visiting_order

    # should return landmarks = the list of Landmark (ordered list)
    #return("max steps :", max_steps, "\n", visiting_order)


"""# keep this for debug
if __name__ == "__main__":
    main()"""