from pydantic import BaseModel
from .landmarktype import LandmarkType
from .preferences import Preferences

class LandmarkTest(BaseModel) :
    name : str
    attractiveness : int
    loc : tuple

# Output to frontend
class Landmark(BaseModel) :
    name : str
    type: LandmarkType      # De facto mapping depending on how the query was executed with overpass. Should still EXACTLY correspond to the preferences
    location : tuple

    # loop through the preferences and assign a score to the landmark
    def score(self, preferences: Preferences):

        for preference_name, preference in preferences.__dict__.items():
            
            if (preference_name == self.type.landmark_type) :
                score = preference.score
        
        if (not score) :
            raise Exception(f"Could not determine score for landmark {self.name}")

        else :
            return score


